// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from ublox_msgs:msg/CfgNAV5.idl
// generated code does not contain a copyright notice

#ifndef UBLOX_MSGS__MSG__DETAIL__CFG_NAV5__TRAITS_HPP_
#define UBLOX_MSGS__MSG__DETAIL__CFG_NAV5__TRAITS_HPP_

#include "ublox_msgs/msg/detail/cfg_nav5__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

namespace rosidl_generator_traits
{

inline void to_yaml(
  const ublox_msgs::msg::CfgNAV5 & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: mask
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "mask: ";
    value_to_yaml(msg.mask, out);
    out << "\n";
  }

  // member: dyn_model
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dyn_model: ";
    value_to_yaml(msg.dyn_model, out);
    out << "\n";
  }

  // member: fix_mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "fix_mode: ";
    value_to_yaml(msg.fix_mode, out);
    out << "\n";
  }

  // member: fixed_alt
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "fixed_alt: ";
    value_to_yaml(msg.fixed_alt, out);
    out << "\n";
  }

  // member: fixed_alt_var
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "fixed_alt_var: ";
    value_to_yaml(msg.fixed_alt_var, out);
    out << "\n";
  }

  // member: min_elev
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "min_elev: ";
    value_to_yaml(msg.min_elev, out);
    out << "\n";
  }

  // member: dr_limit
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dr_limit: ";
    value_to_yaml(msg.dr_limit, out);
    out << "\n";
  }

  // member: p_dop
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "p_dop: ";
    value_to_yaml(msg.p_dop, out);
    out << "\n";
  }

  // member: t_dop
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "t_dop: ";
    value_to_yaml(msg.t_dop, out);
    out << "\n";
  }

  // member: p_acc
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "p_acc: ";
    value_to_yaml(msg.p_acc, out);
    out << "\n";
  }

  // member: t_acc
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "t_acc: ";
    value_to_yaml(msg.t_acc, out);
    out << "\n";
  }

  // member: static_hold_thresh
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "static_hold_thresh: ";
    value_to_yaml(msg.static_hold_thresh, out);
    out << "\n";
  }

  // member: dgnss_time_out
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dgnss_time_out: ";
    value_to_yaml(msg.dgnss_time_out, out);
    out << "\n";
  }

  // member: cno_thresh_num_svs
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cno_thresh_num_svs: ";
    value_to_yaml(msg.cno_thresh_num_svs, out);
    out << "\n";
  }

  // member: cno_thresh
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cno_thresh: ";
    value_to_yaml(msg.cno_thresh, out);
    out << "\n";
  }

  // member: reserved1
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.reserved1.size() == 0) {
      out << "reserved1: []\n";
    } else {
      out << "reserved1:\n";
      for (auto item : msg.reserved1) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: static_hold_max_dist
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "static_hold_max_dist: ";
    value_to_yaml(msg.static_hold_max_dist, out);
    out << "\n";
  }

  // member: utc_standard
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "utc_standard: ";
    value_to_yaml(msg.utc_standard, out);
    out << "\n";
  }

  // member: reserved2
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.reserved2.size() == 0) {
      out << "reserved2: []\n";
    } else {
      out << "reserved2:\n";
      for (auto item : msg.reserved2) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ublox_msgs::msg::CfgNAV5 & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<ublox_msgs::msg::CfgNAV5>()
{
  return "ublox_msgs::msg::CfgNAV5";
}

template<>
inline const char * name<ublox_msgs::msg::CfgNAV5>()
{
  return "ublox_msgs/msg/CfgNAV5";
}

template<>
struct has_fixed_size<ublox_msgs::msg::CfgNAV5>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<ublox_msgs::msg::CfgNAV5>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<ublox_msgs::msg::CfgNAV5>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // UBLOX_MSGS__MSG__DETAIL__CFG_NAV5__TRAITS_HPP_
