// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from ublox_msgs:msg/MonGNSS.idl
// generated code does not contain a copyright notice

#ifndef UBLOX_MSGS__MSG__DETAIL__MON_GNSS__TRAITS_HPP_
#define UBLOX_MSGS__MSG__DETAIL__MON_GNSS__TRAITS_HPP_

#include "ublox_msgs/msg/detail/mon_gnss__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

namespace rosidl_generator_traits
{

inline void to_yaml(
  const ublox_msgs::msg::MonGNSS & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: version
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "version: ";
    value_to_yaml(msg.version, out);
    out << "\n";
  }

  // member: supported
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "supported: ";
    value_to_yaml(msg.supported, out);
    out << "\n";
  }

  // member: default_gnss
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "default_gnss: ";
    value_to_yaml(msg.default_gnss, out);
    out << "\n";
  }

  // member: enabled
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "enabled: ";
    value_to_yaml(msg.enabled, out);
    out << "\n";
  }

  // member: simultaneous
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "simultaneous: ";
    value_to_yaml(msg.simultaneous, out);
    out << "\n";
  }

  // member: reserved1
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.reserved1.size() == 0) {
      out << "reserved1: []\n";
    } else {
      out << "reserved1:\n";
      for (auto item : msg.reserved1) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ublox_msgs::msg::MonGNSS & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<ublox_msgs::msg::MonGNSS>()
{
  return "ublox_msgs::msg::MonGNSS";
}

template<>
inline const char * name<ublox_msgs::msg::MonGNSS>()
{
  return "ublox_msgs/msg/MonGNSS";
}

template<>
struct has_fixed_size<ublox_msgs::msg::MonGNSS>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<ublox_msgs::msg::MonGNSS>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<ublox_msgs::msg::MonGNSS>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // UBLOX_MSGS__MSG__DETAIL__MON_GNSS__TRAITS_HPP_
