// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from ublox_msgs:msg/CfgUSB.idl
// generated code does not contain a copyright notice

#ifndef UBLOX_MSGS__MSG__DETAIL__CFG_USB__TRAITS_HPP_
#define UBLOX_MSGS__MSG__DETAIL__CFG_USB__TRAITS_HPP_

#include "ublox_msgs/msg/detail/cfg_usb__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

namespace rosidl_generator_traits
{

inline void to_yaml(
  const ublox_msgs::msg::CfgUSB & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: vendor_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "vendor_id: ";
    value_to_yaml(msg.vendor_id, out);
    out << "\n";
  }

  // member: product_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "product_id: ";
    value_to_yaml(msg.product_id, out);
    out << "\n";
  }

  // member: reserved1
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.reserved1.size() == 0) {
      out << "reserved1: []\n";
    } else {
      out << "reserved1:\n";
      for (auto item : msg.reserved1) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: reserved2
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.reserved2.size() == 0) {
      out << "reserved2: []\n";
    } else {
      out << "reserved2:\n";
      for (auto item : msg.reserved2) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: power_consumption
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "power_consumption: ";
    value_to_yaml(msg.power_consumption, out);
    out << "\n";
  }

  // member: flags
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "flags: ";
    value_to_yaml(msg.flags, out);
    out << "\n";
  }

  // member: vendor_string
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.vendor_string.size() == 0) {
      out << "vendor_string: []\n";
    } else {
      out << "vendor_string:\n";
      for (auto item : msg.vendor_string) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: product_string
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.product_string.size() == 0) {
      out << "product_string: []\n";
    } else {
      out << "product_string:\n";
      for (auto item : msg.product_string) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: serial_number
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.serial_number.size() == 0) {
      out << "serial_number: []\n";
    } else {
      out << "serial_number:\n";
      for (auto item : msg.serial_number) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ublox_msgs::msg::CfgUSB & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<ublox_msgs::msg::CfgUSB>()
{
  return "ublox_msgs::msg::CfgUSB";
}

template<>
inline const char * name<ublox_msgs::msg::CfgUSB>()
{
  return "ublox_msgs/msg/CfgUSB";
}

template<>
struct has_fixed_size<ublox_msgs::msg::CfgUSB>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<ublox_msgs::msg::CfgUSB>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<ublox_msgs::msg::CfgUSB>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // UBLOX_MSGS__MSG__DETAIL__CFG_USB__TRAITS_HPP_
